import { reactive as z, computed as V, readonly as F, openBlock as u, createElementBlock as h, createElementVNode as i, defineComponent as P, ref as M, onMounted as E, onUnmounted as I, normalizeClass as W, renderSlot as _, normalizeProps as p, guardReactiveProps as m, mergeProps as Z, createBlock as O, resolveDynamicComponent as A, createCommentVNode as S, toDisplayString as b, withModifiers as U, createVNode as H, Teleport as G, normalizeStyle as K, unref as j, TransitionGroup as R, withCtx as C, Fragment as X, renderList as q } from "vue";
const N = {
  theme: {
    top: "0",
    bottom: "auto",
    left: "0",
    right: "auto",
    iconSize: "40px",
    successColor: "rgba(43, 222, 63, 1)",
    warnColor: "rgba(255, 192, 7, 1)",
    infoColor: "rgba(29, 114, 243, 1)",
    errorColor: "rgba(222, 9, 9, 1)",
    gray: "rgba(170, 170, 170, 1)",
    toasterMaxWidth: "500px",
    animationDuration: 1e3,
    animationFunction: "ease-in-out",
    translateX: "200px",
    direction: 1,
    toastBackgroundColor: "#fff"
  },
  closable: !0,
  pauseOnHover: !0,
  closeOnDoubleClick: !0,
  duration: 10
};
function J() {
  return Math.random().toString(36).substring(2, 9);
}
function Q() {
  return {
    id: J(),
    type: "info",
    title: "info",
    text: "this is your info",
    options: N
  };
}
function Y(n) {
  const t = {};
  for (const e in n)
    t[`--${e}`] = n[e];
  return t;
}
function B(n = {}, t = {}) {
  const e = D(n), s = D(t);
  for (const r in e)
    e && typeof e[r] == "object" && e.hasOwnProperty(r) && !Array.isArray(e[r]) && (e[r] = Object.assign({}, e[r], s[r]), delete s[r]);
  return Object.assign(e, s);
}
function D(n) {
  const t = {};
  if (typeof n != "object")
    return n;
  for (const e in n)
    n[e] != null && (t[e] = D(n[e]));
  return t;
}
const k = {
  interfaces: {
    link: "https://github.com/hackcharms/vue3-toaster#interfaces",
    Toaster: "https://github.com/hackcharms/vue3-toaster#interfaces",
    ToastVariant: "https://github.com/hackcharms/vue3-toaster#interfaces"
  },
  methods: {
    link: "https://github.com/hackcharms/vue3-toaster#methods",
    success: "https://github.com/hackcharms/vue3-toaster#success",
    warn: "https://github.com/hackcharms/vue3-toaster#warn",
    info: "https://github.com/hackcharms/vue3-toaster#info",
    error: "https://github.com/hackcharms/vue3-toaster#error"
  },
  slots: {
    link: "https://github.com/hackcharms/vue3-toaster#slots"
  },
  events: {
    link: "https://github.com/hackcharms/vue3-toaster#events"
  }
};
function tt(n, t) {
  const e = Q();
  n.options = B(t, n.options);
  let s = B(e, n);
  return ["error", "info", "success", "warn"].includes(
    s == null ? void 0 : s.type
  ) || (console.warn(
    `"${s.type}" is not a valid type using default type info
        @see ${k.interfaces.ToastVariant} for "ToastVariant" interfaces
        `
  ), s.type = e.type), s.title || (s.title = s.type), s;
}
const y = z([]);
function x() {
  function n(o) {
    const c = T().all, l = tt(
      Object.assign({}, o),
      c.value
    );
    return y.push(l), l.id;
  }
  function t({
    message: o = "info",
    type: c = "info"
  }) {
    var l, $;
    if (!["string", "object"].includes(typeof o)) {
      console.warn(
        `${c} function accept only typeof string or Object with "Toaster" interface
            @see ${k.interfaces.Toaster} for interfaces
            ${(l = k.methods) != null && l[c] ? "or @see " + (($ = k.methods) == null ? void 0 : $[c]) : ""}
            `
      );
      return;
    }
    return n(typeof o == "string" ? {
      type: c,
      text: o
    } : o);
  }
  function e(o) {
    return t({
      message: {
        type: "success",
        title: "Success",
        text: o
      }
    });
  }
  function s(o) {
    return t({
      message: {
        type: "info",
        title: "Information",
        text: o
      }
    });
  }
  function r(o) {
    return t({
      message: {
        type: "warn",
        title: "Warning",
        text: o
      }
    });
  }
  function f(o) {
    return t({
      message: {
        type: "error",
        title: "Error",
        text: o
      }
    });
  }
  function a(o) {
    let c = y.findIndex((l) => l.id === o);
    return c < 0 ? console.warn(`No active Toaster Found with Id "${o}"`) : (y.splice(c, 1), o);
  }
  function L(o) {
    return (!o || !(o != null && o.length)) && (o = y.map((c) => c.id)), o != null && o.length && o.forEach((c) => a(c)), o;
  }
  const g = V(() => y);
  return {
    add: n,
    success: e,
    warn: r,
    error: f,
    info: s,
    remove: a,
    clear: L,
    toasters: g
  };
}
const w = z(
  Object.assign({}, N)
);
function T() {
  function n(e) {
    var s, r, f, a;
    return (s = e == null ? void 0 : e.theme) != null && s.bottom && ((r = e.theme) == null ? void 0 : r.bottom) !== "auto" && (w.theme.top = "auto"), (f = e == null ? void 0 : e.theme) != null && f.right && ((a = e.theme) == null ? void 0 : a.right) !== "auto" && (w.theme.left = "auto"), Object.assign(w, B(w, e)), t;
  }
  const t = V(() => w);
  return {
    update: n,
    all: t,
    cssVariables: F(Y(t.value.theme))
  };
}
const v = (n, t) => {
  const e = n.__vccOpts || n;
  for (const [s, r] of t)
    e[s] = r;
  return e;
}, et = {}, nt = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24",
  "stroke-width": "2",
  stroke: "currentColor",
  fill: "none",
  "stroke-linecap": "round",
  "stroke-linejoin": "round"
}, ot = /* @__PURE__ */ i("path", { d: "M12 12m-9 0a9 9 0 1 0 18 0a9 9 0 1 0 -18 0" }, null, -1), st = /* @__PURE__ */ i("path", { d: "M9 12l2 2l4 -4" }, null, -1), rt = [
  ot,
  st
];
function ct(n, t) {
  return u(), h("svg", nt, rt);
}
const it = /* @__PURE__ */ v(et, [["render", ct]]), at = {}, lt = {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 24 24",
  fill: "none"
}, ut = /* @__PURE__ */ i("path", {
  d: "M12 4a8 8 0 1 0 0 16 8 8 0 0 0 0-16zM2 12C2 6.477 6.477 2 12 2s10 4.477 10 10-4.477 10-10 10S2 17.523 2 12zm5.793-4.207a1 1 0 0 1 1.414 0L12 10.586l2.793-2.793a1 1 0 1 1 1.414 1.414L13.414 12l2.793 2.793a1 1 0 0 1-1.414 1.414L12 13.414l-2.793 2.793a1 1 0 0 1-1.414-1.414L10.586 12 7.793 9.207a1 1 0 0 1 0-1.414z",
  fill: "currentColor"
}, null, -1), ft = [
  ut
];
function dt(n, t) {
  return u(), h("svg", lt, ft);
}
const _t = /* @__PURE__ */ v(at, [["render", dt]]), ht = {}, pt = {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 12 12",
  fill: "none"
}, mt = /* @__PURE__ */ i("path", {
  d: "M5.25 8.25C5.25 7.83579 5.58579 7.5 6 7.5C6.41421 7.5 6.75 7.83579 6.75 8.25C6.75 8.66421 6.41421 9 6 9C5.58579 9 5.25 8.66421 5.25 8.25ZM5.50806 3.41012C5.55039 3.17688 5.75454 3 6 3C6.24546 3 6.44961 3.17688 6.49194 3.41012L6.5 3.5V6L6.49194 6.08988C6.44961 6.32312 6.24546 6.5 6 6.5C5.75454 6.5 5.55039 6.32312 5.50806 6.08988L5.5 6V3.5L5.50806 3.41012ZM11 6C11 8.76142 8.76142 11 6 11C3.23858 11 1 8.76142 1 6C1 3.23858 3.23858 1 6 1C8.76142 1 11 3.23858 11 6ZM10 6C10 3.79086 8.20914 2 6 2C3.79086 2 2 3.79086 2 6C2 8.20914 3.79086 10 6 10C8.20914 10 10 8.20914 10 6Z",
  fill: "currentColor"
}, null, -1), vt = [
  mt
];
function gt(n, t) {
  return u(), h("svg", pt, vt);
}
const Ct = /* @__PURE__ */ v(ht, [["render", gt]]), yt = {}, wt = {
  xmlns: "http://www.w3.org/2000/svg",
  width: "24",
  height: "24",
  viewBox: "0 0 24 24",
  fill: "none",
  stroke: "currentColor",
  "stroke-width": "2",
  "stroke-linecap": "round",
  "stroke-linejoin": "round"
}, $t = /* @__PURE__ */ i("circle", {
  cx: "12",
  cy: "12",
  r: "10"
}, null, -1), bt = /* @__PURE__ */ i("line", {
  x1: "12",
  y1: "16",
  x2: "12",
  y2: "12"
}, null, -1), kt = /* @__PURE__ */ i("line", {
  x1: "12",
  y1: "8",
  x2: "12.01",
  y2: "8"
}, null, -1), xt = [
  $t,
  bt,
  kt
];
function Tt(n, t) {
  return u(), h("svg", wt, xt);
}
const Lt = /* @__PURE__ */ v(yt, [["render", Tt]]), Mt = {}, Ot = {
  width: "24",
  height: "24",
  viewBox: "0 0 24 24",
  fill: "none",
  xmlns: "http://www.w3.org/2000/svg"
}, Bt = /* @__PURE__ */ i("path", {
  d: "M6.2253 4.81108C5.83477 4.42056 5.20161 4.42056 4.81108 4.81108C4.42056 5.20161 4.42056 5.83477 4.81108 6.2253L10.5858 12L4.81114 17.7747C4.42062 18.1652 4.42062 18.7984 4.81114 19.1889C5.20167 19.5794 5.83483 19.5794 6.22535 19.1889L12 13.4142L17.7747 19.1889C18.1652 19.5794 18.7984 19.5794 19.1889 19.1889C19.5794 18.7984 19.5794 18.1652 19.1889 17.7747L13.4142 12L19.189 6.2253C19.5795 5.83477 19.5795 5.20161 19.189 4.81108C18.7985 4.42056 18.1653 4.42056 17.7748 4.81108L12 10.5858L6.2253 4.81108Z",
  fill: "currentColor"
}, null, -1), Dt = [
  Bt
];
function Vt(n, t) {
  return u(), h("svg", Ot, Dt);
}
const St = /* @__PURE__ */ v(Mt, [["render", Vt]]), jt = { class: "ts__toaster" }, zt = { class: "ts__content" }, Pt = { class: "ts__type ts__type-text" }, Et = { class: "ts__message" }, Zt = ["onClick"], Ht = /* @__PURE__ */ P({
  __name: "Toast",
  props: {
    id: {},
    title: { default: "Info" },
    type: { default: "info" },
    text: { default: "This is your information" },
    options: {}
  },
  setup(n) {
    const t = n, e = V(() => ({
      success: it,
      info: Lt,
      warn: Ct,
      error: _t
    })[t.type]), s = {
      onMouseover: f,
      onMouseleave: a,
      onDblclick: L
    };
    function r(d) {
      c.value = d;
    }
    function f(d) {
      t.options.pauseOnHover && r(!0);
    }
    function a(d) {
      t.options.pauseOnHover && r(!1);
    }
    function L() {
      t.options.closeOnDoubleClick && l();
    }
    const g = M(t.options.duration), o = M(0), c = M(!1);
    function l() {
      x().remove(t.id);
    }
    function $() {
      o.value = window.setInterval(() => {
        g.value <= 0 && l(), c.value || g.value--;
      }, 1e3);
    }
    return E(() => {
      $();
    }), I(() => {
      o.value && window.clearInterval(o.value);
    }), (d, At) => (u(), h("div", jt, [
      i("div", {
        class: W(["toast ts__content-center", `ts__${t.type}`])
      }, [
        _(d.$slots, "default", p(m({
          ...t,
          destroyToaster: l,
          pauseCountdown: r
        })), () => [
          i("div", Z({ class: "ts__content-center" }, s), [
            i("div", null, [
              _(d.$slots, "icon", p(m({ title: t.title, type: t.type })), () => [
                e.value ? (u(), O(A(e.value), {
                  key: 0,
                  class: "ts__icon ts__icon-color"
                })) : S("", !0)
              ], !0)
            ]),
            i("div", zt, [
              _(d.$slots, "content", p(m({
                title: t.title,
                text: t.text,
                type: t.type
              })), () => [
                i("p", Pt, b(t.title || t.type) + " #" + b(t.id) + " " + b(g.value), 1),
                i("p", Et, b(t.text), 1)
              ], !0)
            ]),
            t.options.closable ? (u(), h("div", {
              key: 0,
              class: "ts__close ts__content-center",
              onClick: U(l, ["stop"])
            }, [
              _(d.$slots, "clearIcon", {}, () => [
                H(St, { class: "ts__text-gray ts__close-icon" })
              ], !0)
            ], 8, Zt)) : S("", !0)
          ], 16)
        ], !0)
      ], 2)
    ]));
  }
});
const Nt = /* @__PURE__ */ v(Ht, [["__scopeId", "data-v-7833fe43"]]), Ft = { class: "container" }, It = /* @__PURE__ */ P({
  __name: "ToastContainer",
  props: {
    pauseOnHover: { type: Boolean },
    closable: { type: Boolean },
    closeOnDoubleClick: { type: Boolean },
    duration: {},
    theme: {}
  },
  setup(n) {
    const t = n, e = x().toasters;
    return E(() => {
      Object.keys(t).length && T().update(t);
    }), (s, r) => (u(), O(G, { to: "body" }, [
      i("div", {
        class: "main-container",
        style: K(j(T)().cssVariables)
      }, [
        i("div", Ft, [
          H(R, {
            name: "ts__animation",
            tag: "div"
          }, {
            default: C(() => [
              (u(!0), h(X, null, q(j(e), (f) => (u(), O(Nt, Z({
                key: f.id
              }, f), {
                default: C((a) => [
                  _(s.$slots, "default", p(m(a)), void 0, !0)
                ]),
                content: C((a) => [
                  _(s.$slots, "content", p(m(a)), void 0, !0)
                ]),
                icon: C((a) => [
                  _(s.$slots, "icon", p(m(a)), void 0, !0)
                ]),
                clearIcon: C((a) => [
                  _(s.$slots, "clearIcon", p(m(a)), void 0, !0)
                ]),
                _: 2
              }, 1040))), 128))
            ]),
            _: 3
          })
        ])
      ], 4)
    ]));
  }
});
const Wt = /* @__PURE__ */ v(It, [["__scopeId", "data-v-6c6008a0"]]), Gt = {
  install: (n, t) => {
    T().update(t), n.config.globalProperties.$toast = x(), n.component("ToastContainer", Wt), n.provide("$toast", x());
  }
};
export {
  Wt as ToastContainer,
  Gt as default,
  N as defaultConfig,
  x as useToaster,
  T as useToasterConfig
};
//# sourceMappingURL=index.es.js.map
